searchNodes=[{"doc":"Provides encoding and decoding functionality for UPER-encoded DSRC message payloads defined by the J2735 standard defined by the Society for Automotive Engineers. Kitt uses Erlang's native ASN1 compiler to parse the raw binary of the DSRC messages and then converts them to Elixir structs for language-native enforcement of required message fields, interactions with message data frames/elements, and more flexible conversion to common interchange formats such as JSON, Protobuf, Avro, etc.","ref":"Kitt.html","title":"Kitt","type":"module"},{"doc":"Decodes a message wrapped in a message frame, tagged with the message type identifying integer as the second byte of the message, to a Kitt Elixir struct representing the messaage content. Defaults the expected input format of the message to a hexadecimal string. Optionally specify the input format with the option format: :hex | :binary . Returns the decoded message as {:ok, %Struct{}} or {:error, reason} Example iex&gt; Kitt . decode ( &lt;&lt; 0 , 29 , 45 , 115 , 204 , 33 , 222 , 6 , 2 , 3 , 148 , 0 , 0 , 15 , 172 , 20 , 128 , 128 , 60 , ...&gt; 243 , 8 , 136 , 219 , 128 , 250 , 12 , 0 , 0 , 0 , 18 , 200 , 72 , 25 , 169 , 126 , 102 , 237 , ...&gt; 196 , 79 , 141 , 137 , 130 , 157 , 132 , 176 , 56 , 121 , 128 &gt;&gt; , format : :binary ) { :ok , % Kitt.Message.SRM { regional : nil , requestor : %{ id : { :entityID , 601 } , position : %{ heading : 4800 , position : %{ elevation : 1260 , lat : 374230638 , long : - 1221420467 } , speed : %{ speed : 486 , transmisson : :unavailable } } , type : %{ hpmsType : :bus , role : :transit } } , requests : [ %{ duration : 2000 , minute : 497732 , request : %{ id : %{ id : 1003 , region : 0 } , inBoundLane : { :lane , 8 } , outBoundLane : { :lane , 30 } , requestID : 5 , requestType : :priorityRequest } , second : 18140 } ] , second : 48140 , sequenceNumber : 2 , timeStamp : 497731 } }","ref":"Kitt.html#decode/2","title":"Kitt.decode/2","type":"function"},{"doc":"The same as decode/2 but returns the encoded message directly, else raises a DSRCDecodeError Example iex&gt; Kitt . decode! ( &quot;001D2D73CC21DE0602039400000FAC1480803CF30888DB80FA0C00000012C84819A97E66EDC44F8D89829D84B0387980&quot; ) % Kitt.Message.SRM { regional : nil , requestor : %{ id : { :entityID , 601 } , position : %{ heading : 4800 , position : %{ elevation : 1260 , lat : 374230638 , long : - 1221420467 } , speed : %{ speed : 486 , transmisson : :unavailable } } , type : %{ hpmsType : :bus , role : :transit } } , requests : [ %{ duration : 2000 , minute : 497732 , request : %{ id : %{ id : 1003 , region : 0 } , inBoundLane : { :lane , 8 } , outBoundLane : { :lane , 30 } , requestID : 5 , requestType : :priorityRequest } , second : 18140 } ] , second : 48140 , sequenceNumber : 2 , timeStamp : 497731 }","ref":"Kitt.html#decode!/2","title":"Kitt.decode!/2","type":"function"},{"doc":"Encodes a message struct wrapped in a message frame, tagged with the message type identifying integer as the second byte of the message. Defaults the format of the encoded message to a hexadecimal string. Optionally specify the desired output format with the option format: :hex | :binary . Returns the encoded message as {:ok, encoded_message} or {:error, reason} Example iex&gt; Kitt . encode ( % Kitt.Message.BSM { ...&gt; coreData : % Kitt.Message.BSM.CoreData { ...&gt; accelSet : %{ lat : 2001 , long : 2001 , vert : - 127 , yaw : 0 } , ...&gt; accuracy : %{ orientation : 65535 , semiMajor : 255 , semiMinor : 255 } , ...&gt; angle : 127 , ...&gt; brakes : %{ ...&gt; abs : :unavailable , ...&gt; auxBrakes : :unavailable , ...&gt; brakeBoost : :unavailable , ...&gt; scs : :unavailable , ...&gt; traction : :unavailable , ...&gt; wheelBrakes : [ :unavailable ] ...&gt; } , ...&gt; elev : 1260 , ...&gt; heading : 4800 , ...&gt; id : &lt;&lt; 0 , 0 , 2 , 89 &gt;&gt; , ...&gt; lat : 374_230_638 , ...&gt; long : - 1_221_420_467 , ...&gt; msgCnt : 1 , ...&gt; secMark : 43476 , ...&gt; size : %{ length : 1200 , width : 300 } , ...&gt; speed : 486 , ...&gt; transmission : :unavailable ...&gt; } , ...&gt; partII : nil , ...&gt; regional : nil ...&gt; } ) { :ok , &quot;00142500400000966A7525F99BB7113E36260A767FFFFFFFF0F312C0FDFA1FA1007FFF8000962580&quot; }","ref":"Kitt.html#encode/2","title":"Kitt.encode/2","type":"function"},{"doc":"The same as encode/2 but returns the encoded message directly, else raises a DSRCEncodeError Example iex&gt; Kitt . encode! ( % Kitt.Message.BSM { ...&gt; coreData : % Kitt.Message.BSM.CoreData { ...&gt; accelSet : %{ lat : 2001 , long : 2001 , vert : - 127 , yaw : 0 } , ...&gt; accuracy : %{ orientation : 65535 , semiMajor : 255 , semiMinor : 255 } , ...&gt; angle : 127 , ...&gt; brakes : %{ ...&gt; abs : :unavailable , ...&gt; auxBrakes : :unavailable , ...&gt; brakeBoost : :unavailable , ...&gt; scs : :unavailable , ...&gt; traction : :unavailable , ...&gt; wheelBrakes : [ :unavailable ] ...&gt; } , ...&gt; elev : 1260 , ...&gt; heading : 4800 , ...&gt; id : &lt;&lt; 0 , 0 , 2 , 89 &gt;&gt; , ...&gt; lat : 374_230_638 , ...&gt; long : - 1_221_420_467 , ...&gt; msgCnt : 1 , ...&gt; secMark : 43476 , ...&gt; size : %{ length : 1200 , width : 300 } , ...&gt; speed : 486 , ...&gt; transmission : :unavailable ...&gt; } , ...&gt; partII : nil , ...&gt; regional : nil ...&gt; } , format : :binary ) &lt;&lt; 0 , 20 , 37 , 0 , 64 , 0 , 0 , 150 , 106 , 117 , 37 , 249 , 155 , 183 , 17 , 62 , 54 , 38 , 10 , 118 , 127 , 255 , 255 , 255 , 240 , 243 , 18 , 192 , 253 , 250 , 31 , 161 , 0 , 127 , 255 , 128 , 0 , 150 , 37 , 128 &gt;&gt;","ref":"Kitt.html#encode!/2","title":"Kitt.encode!/2","type":"function"},{"doc":"Encoding and decoding functions for specific message types and frame defined by the J2735-standard. Calls the lower-level :DSRC functions generated by the ASN1 definition files and converts the resulting maps to Elixir structs as well as the reverse order for conversion from maps and structs to hexadecimal or binary encoded messages","ref":"Kitt.Encoder.html","title":"Kitt.Encoder","type":"module"},{"doc":"Takes an encoded DSRC Message Frame and decodes it to a Kitt struct of the encoded type. Data elements contained within the struct as sub-values with a defined Kitt struct type are recursively instantiated as well. The default input format is a hexadecimal string encoding unless specified by passing the optional keyword argument format: :hex | :binary Returns the struct wrapped in an :ok tuple or an {:error, reason} tuple.","ref":"Kitt.Encoder.html#decode_frame/2","title":"Kitt.Encoder.decode_frame/2","type":"function"},{"doc":"The same as Kitt.decode_frame/2 but returns the decoded message struct directly without the :ok tuple wrapper or raises a DSRCDecodeError exception.","ref":"Kitt.Encoder.html#decode_frame!/2","title":"Kitt.Encoder.decode_frame!/2","type":"function"},{"doc":"Takes a binary encoded J2735 message and an explicit message type atom and decodes the message to a Kitt struct. Any sub-fields of the struct that are defined by Kitt as a struct are recursively instantiated. By default the binary message is assumed to be in a hexadecimal string but the input format can be explicitly supplied via the keyword argument format: :hex | :binary . Returns the resulting message struct wrapped in an :ok tuple, else returns {:error, reason} .","ref":"Kitt.Encoder.html#decode_message/3","title":"Kitt.Encoder.decode_message/3","type":"function"},{"doc":"Same as decode_message/3 but returns the decoded struct directly or else raises a DSRCDecodeError exception.","ref":"Kitt.Encoder.html#decode_message!/3","title":"Kitt.Encoder.decode_message!/3","type":"function"},{"doc":"Takes a Kitt message struct and converts it to either a binary or hex version of the message data wrapped in a Message Frame structure tagged with the appropriate ID number. The default output format is hexadecimal. Optionally define the desired output by passing the keyword flag format: :hex | :binary . Returns the encoded message wrapped in an :ok tuple or an {:error, reason} tuple.","ref":"Kitt.Encoder.html#encode_frame/2","title":"Kitt.Encoder.encode_frame/2","type":"function"},{"doc":"The same as Kitt.encode_frame/2 but returns the encoded message binary directly without the :ok tuple wrapper or raises a DSRCEncodeError exception.","ref":"Kitt.Encoder.html#encode_frame!/2","title":"Kitt.Encoder.encode_frame!/2","type":"function"},{"doc":"Takes a Kitt message struct or comparable message data as a basic Elixir map as well as an explicit message type atom and encodes the message to a binary representation of the message. By default the message is encoded to a hexadecimal representation but the optional keyword argument format: :hex | :binary can explicitly define the desired output format. Resulting binary is wrapped in an :ok tuple, else an {:error, reason} is returned.","ref":"Kitt.Encoder.html#encode_message/3","title":"Kitt.Encoder.encode_message/3","type":"function"},{"doc":"Same as encode_message/3 but returns the encoded message binary directly or else raises a DSRCEncodeError exception.","ref":"Kitt.Encoder.html#encode_message!/3","title":"Kitt.Encoder.encode_message!/3","type":"function"},{"doc":"Takes a Kitt message struct and encodes it to a binary representation of the message. By default the message is encoded to a hexadecimal representation but the optional keyword argument format: :hex | :binary can explicitly define the desired output format. Resulting binary is wrapped in an :ok tuple, else an {:error, reason} is returned.","ref":"Kitt.Encoder.html#encode_struct/2","title":"Kitt.Encoder.encode_struct/2","type":"function"},{"doc":"Same as encode_struct/2 but returns the encoded message binary directly or else raises a DSRCEncodeError exception.","ref":"Kitt.Encoder.html#encode_struct!/2","title":"Kitt.Encoder.encode_struct!/2","type":"function"},{"doc":"A struct-encoded instance of a J2735 standard message","ref":"Kitt.Encoder.html#t:message/0","title":"Kitt.Encoder.message/0","type":"type"},{"doc":"Defines the structure and instantiation function for creating a J2735-compliant BasicSafetyMessage A BSM defines the basic interchange of presence data between DSRC-capable vehicles and infrastructure","ref":"Kitt.Message.BSM.html","title":"Kitt.Message.BSM","type":"module"},{"doc":"Produces a BSM message struct from an equivalent map or keyword input. The coreData primary field is instantiated as a CoreData struct recursively","ref":"Kitt.Message.BSM.html#new/1","title":"Kitt.Message.BSM.new/1","type":"function"},{"doc":"Returns the BSM identifying atom recognized by the ASN1 spec","ref":"Kitt.Message.BSM.html#type/0","title":"Kitt.Message.BSM.type/0","type":"function"},{"doc":"Returns the BSM identifying integer","ref":"Kitt.Message.BSM.html#type_id/0","title":"Kitt.Message.BSM.type_id/0","type":"function"},{"doc":"","ref":"Kitt.Message.BSM.html#t:lights_state/0","title":"Kitt.Message.BSM.lights_state/0","type":"type"},{"doc":"","ref":"Kitt.Message.BSM.html#t:partIIcontent/0","title":"Kitt.Message.BSM.partIIcontent/0","type":"type"},{"doc":"","ref":"Kitt.Message.BSM.html#t:partIIextension/0","title":"Kitt.Message.BSM.partIIextension/0","type":"type"},{"doc":"","ref":"Kitt.Message.BSM.html#t:special_vehicle_extensions/0","title":"Kitt.Message.BSM.special_vehicle_extensions/0","type":"type"},{"doc":"","ref":"Kitt.Message.BSM.html#t:supplemental_vehicle_extensions/0","title":"Kitt.Message.BSM.supplemental_vehicle_extensions/0","type":"type"},{"doc":"Defines the BasicSafetyMessage type and the data elements comprising its component fields","ref":"Kitt.Message.BSM.html#t:t/0","title":"Kitt.Message.BSM.t/0","type":"type"},{"doc":"","ref":"Kitt.Message.BSM.html#t:vehicle_safety_extensions/0","title":"Kitt.Message.BSM.vehicle_safety_extensions/0","type":"type"},{"doc":"Defines the structure and instantiation function for creating a J2735-compliant BSMCoreData data element","ref":"Kitt.Message.BSM.CoreData.html","title":"Kitt.Message.BSM.CoreData","type":"module"},{"doc":"Produces a CoreData message struct from an equivalent map or keyword input.","ref":"Kitt.Message.BSM.CoreData.html#new/1","title":"Kitt.Message.BSM.CoreData.new/1","type":"function"},{"doc":"Defines the structure of a BSMCoreData data element and the data elements comprising its fields","ref":"Kitt.Message.BSM.CoreData.html#t:t/0","title":"Kitt.Message.BSM.CoreData.t/0","type":"type"},{"doc":"Defines the structure and instantiation function for creating a J2735-compliant Common Safety Request message. A CSR is a message defining the request for safety information from one DSRC-capable vehicle to another.","ref":"Kitt.Message.CSR.html","title":"Kitt.Message.CSR","type":"module"},{"doc":"Produces a CSR message struct from an equivalent map or keyword input","ref":"Kitt.Message.CSR.html#new/1","title":"Kitt.Message.CSR.new/1","type":"function"},{"doc":"Returns the CSR identifying atom recognized by the ASN1 spec","ref":"Kitt.Message.CSR.html#type/0","title":"Kitt.Message.CSR.type/0","type":"function"},{"doc":"Returns the CSR identifying integer","ref":"Kitt.Message.CSR.html#type_id/0","title":"Kitt.Message.CSR.type_id/0","type":"function"},{"doc":"","ref":"Kitt.Message.CSR.html#t:request_item/0","title":"Kitt.Message.CSR.request_item/0","type":"type"},{"doc":"Defines the structure of a CommonSafetyRequest message and the data elements comprising its fields","ref":"Kitt.Message.CSR.html#t:t/0","title":"Kitt.Message.CSR.t/0","type":"type"},{"doc":"Defines the structure and instantiation function for creating a J2735-compliant Emergency Vehicle Alert message An EVA defines the alert message type emitted by emergency vehicles to other DSRC-capable vehicles entering the vicinity of the incident","ref":"Kitt.Message.EVA.html","title":"Kitt.Message.EVA","type":"module"},{"doc":"Produces an EVA message struct from an equivalent map or keyword input","ref":"Kitt.Message.EVA.html#new/1","title":"Kitt.Message.EVA.new/1","type":"function"},{"doc":"Returns the EVA identifying atom recognized by the ASN1 spec","ref":"Kitt.Message.EVA.html#type/0","title":"Kitt.Message.EVA.type/0","type":"function"},{"doc":"Returns the EVA identifying integer","ref":"Kitt.Message.EVA.html#type_id/0","title":"Kitt.Message.EVA.type_id/0","type":"function"},{"doc":"Defines the structure of a EmergencyVehicleAlert message and the data elements comprising its component fields","ref":"Kitt.Message.EVA.html#t:t/0","title":"Kitt.Message.EVA.t/0","type":"type"},{"doc":"Defines the structure and instantiation function for creating a J2735-compliant Intersection Collision Alert message An ICA defines the alert message type that is emitted to DSRC-capable vehicles entering the vicinity of an intersection in which a collision has occurred","ref":"Kitt.Message.ICA.html","title":"Kitt.Message.ICA","type":"module"},{"doc":"Produces an ICA message struct from an equivalent map or keyword input","ref":"Kitt.Message.ICA.html#new/1","title":"Kitt.Message.ICA.new/1","type":"function"},{"doc":"Returns the ICA identifying atom recognized by the ASN1 spec","ref":"Kitt.Message.ICA.html#type/0","title":"Kitt.Message.ICA.type/0","type":"function"},{"doc":"Returns the ICA identifying integer","ref":"Kitt.Message.ICA.html#type_id/0","title":"Kitt.Message.ICA.type_id/0","type":"function"},{"doc":"","ref":"Kitt.Message.ICA.html#t:approach_or_lane/0","title":"Kitt.Message.ICA.approach_or_lane/0","type":"type"},{"doc":"Defines the structure of an IntersectionCollision message and the data elements comprising its fields","ref":"Kitt.Message.ICA.html#t:t/0","title":"Kitt.Message.ICA.t/0","type":"type"},{"doc":"Defines the structure and instantiation function for creating a J2735-compliant MapData message A MapData message defines the geometry of a roadway intersection including the lanes, ingress/egress vectors and other defined rules for traversing the intersection.","ref":"Kitt.Message.MAP.html","title":"Kitt.Message.MAP","type":"module"},{"doc":"Produces a MAP message struct from an equivalent map or keyword input","ref":"Kitt.Message.MAP.html#new/1","title":"Kitt.Message.MAP.new/1","type":"function"},{"doc":"Returns the MAP identifying atom recognized by the ASN1 spec","ref":"Kitt.Message.MAP.html#type/0","title":"Kitt.Message.MAP.type/0","type":"function"},{"doc":"Returns the MAP identifying integer","ref":"Kitt.Message.MAP.html#type_id/0","title":"Kitt.Message.MAP.type_id/0","type":"function"},{"doc":"","ref":"Kitt.Message.MAP.html#t:bike_lane_attribute/0","title":"Kitt.Message.MAP.bike_lane_attribute/0","type":"type"},{"doc":"","ref":"Kitt.Message.MAP.html#t:connecting_lane/0","title":"Kitt.Message.MAP.connecting_lane/0","type":"type"},{"doc":"","ref":"Kitt.Message.MAP.html#t:connection/0","title":"Kitt.Message.MAP.connection/0","type":"type"},{"doc":"","ref":"Kitt.Message.MAP.html#t:crosswalk_lane_attribute/0","title":"Kitt.Message.MAP.crosswalk_lane_attribute/0","type":"type"},{"doc":"","ref":"Kitt.Message.MAP.html#t:data_parameters/0","title":"Kitt.Message.MAP.data_parameters/0","type":"type"},{"doc":"","ref":"Kitt.Message.MAP.html#t:directional_use/0","title":"Kitt.Message.MAP.directional_use/0","type":"type"},{"doc":"","ref":"Kitt.Message.MAP.html#t:generic_lane/0","title":"Kitt.Message.MAP.generic_lane/0","type":"type"},{"doc":"","ref":"Kitt.Message.MAP.html#t:intersection_geometry/0","title":"Kitt.Message.MAP.intersection_geometry/0","type":"type"},{"doc":"","ref":"Kitt.Message.MAP.html#t:lane_attribute_type/0","title":"Kitt.Message.MAP.lane_attribute_type/0","type":"type"},{"doc":"","ref":"Kitt.Message.MAP.html#t:lane_attributes/0","title":"Kitt.Message.MAP.lane_attributes/0","type":"type"},{"doc":"","ref":"Kitt.Message.MAP.html#t:maneuver/0","title":"Kitt.Message.MAP.maneuver/0","type":"type"},{"doc":"","ref":"Kitt.Message.MAP.html#t:median_lane_attribute/0","title":"Kitt.Message.MAP.median_lane_attribute/0","type":"type"},{"doc":"","ref":"Kitt.Message.MAP.html#t:parking_lane_attribute/0","title":"Kitt.Message.MAP.parking_lane_attribute/0","type":"type"},{"doc":"","ref":"Kitt.Message.MAP.html#t:restriction_applies_to/0","title":"Kitt.Message.MAP.restriction_applies_to/0","type":"type"},{"doc":"","ref":"Kitt.Message.MAP.html#t:restriction_class_assignment/0","title":"Kitt.Message.MAP.restriction_class_assignment/0","type":"type"},{"doc":"","ref":"Kitt.Message.MAP.html#t:restriction_user_type/0","title":"Kitt.Message.MAP.restriction_user_type/0","type":"type"},{"doc":"","ref":"Kitt.Message.MAP.html#t:road_segment/0","title":"Kitt.Message.MAP.road_segment/0","type":"type"},{"doc":"","ref":"Kitt.Message.MAP.html#t:shared_with/0","title":"Kitt.Message.MAP.shared_with/0","type":"type"},{"doc":"","ref":"Kitt.Message.MAP.html#t:sidewalk_lane_attribute/0","title":"Kitt.Message.MAP.sidewalk_lane_attribute/0","type":"type"},{"doc":"","ref":"Kitt.Message.MAP.html#t:signal_control_zone/0","title":"Kitt.Message.MAP.signal_control_zone/0","type":"type"},{"doc":"","ref":"Kitt.Message.MAP.html#t:striping_lane_attribute/0","title":"Kitt.Message.MAP.striping_lane_attribute/0","type":"type"},{"doc":"Defines the MapData message and the data elements comprising its fields","ref":"Kitt.Message.MAP.html#t:t/0","title":"Kitt.Message.MAP.t/0","type":"type"},{"doc":"","ref":"Kitt.Message.MAP.html#t:tracked_vehicle_attribute/0","title":"Kitt.Message.MAP.tracked_vehicle_attribute/0","type":"type"},{"doc":"","ref":"Kitt.Message.MAP.html#t:vehicle_lane_attribute/0","title":"Kitt.Message.MAP.vehicle_lane_attribute/0","type":"type"},{"doc":"Defines the structure and instantiation function for creating a J2735-compliant PersonalSafetyMessage. A PSM defines the information exchanged between non-vehicle actors within a DSRC-capable environment and the vehicles and infrastructure of the environment","ref":"Kitt.Message.PSM.html","title":"Kitt.Message.PSM","type":"module"},{"doc":"Produces the PSM message struct from an equivalent map or keyword input","ref":"Kitt.Message.PSM.html#new/1","title":"Kitt.Message.PSM.new/1","type":"function"},{"doc":"Returns the PSM identifying atom recognized by the ASN1 spec","ref":"Kitt.Message.PSM.html#type/0","title":"Kitt.Message.PSM.type/0","type":"function"},{"doc":"Returns the PSM identifying integer","ref":"Kitt.Message.PSM.html#type_id/0","title":"Kitt.Message.PSM.type_id/0","type":"function"},{"doc":"","ref":"Kitt.Message.PSM.html#t:activity/0","title":"Kitt.Message.PSM.activity/0","type":"type"},{"doc":"","ref":"Kitt.Message.PSM.html#t:assistance/0","title":"Kitt.Message.PSM.assistance/0","type":"type"},{"doc":"","ref":"Kitt.Message.PSM.html#t:sizing/0","title":"Kitt.Message.PSM.sizing/0","type":"type"},{"doc":"","ref":"Kitt.Message.PSM.html#t:sub_activity/0","title":"Kitt.Message.PSM.sub_activity/0","type":"type"},{"doc":"Defines the structure of a PersonalSafetyMessage and the data elements comprising its fields","ref":"Kitt.Message.PSM.html#t:t/0","title":"Kitt.Message.PSM.t/0","type":"type"},{"doc":"","ref":"Kitt.Message.PSM.html#t:use_state/0","title":"Kitt.Message.PSM.use_state/0","type":"type"},{"doc":"Defines the structure and instantiation function for creating a J2735-compliant Road Side Alert message An RSA defines the basic message structure for notifying vehicles in entering the vicinity of an event within the roadway","ref":"Kitt.Message.RSA.html","title":"Kitt.Message.RSA","type":"module"},{"doc":"Produces an RSA message struct from an equivalent map or keyword input","ref":"Kitt.Message.RSA.html#new/1","title":"Kitt.Message.RSA.new/1","type":"function"},{"doc":"Returns the RSA identifying atom recognized by the ASN1 spec","ref":"Kitt.Message.RSA.html#type/0","title":"Kitt.Message.RSA.type/0","type":"function"},{"doc":"Returns the RSA identifying integer","ref":"Kitt.Message.RSA.html#type_id/0","title":"Kitt.Message.RSA.type_id/0","type":"function"},{"doc":"Defines the structure of a RoadSideAlert message and the data elements comprising its fields","ref":"Kitt.Message.RSA.html#t:t/0","title":"Kitt.Message.RSA.t/0","type":"type"},{"doc":"Defines the structure and instantiation function for creating a J2735-compliant SignalPhaseandTiming message A SPAT defines the messages generated by the roadside infrastructure regarding current and pending signal status and expected timing of signal status changes.","ref":"Kitt.Message.SPAT.html","title":"Kitt.Message.SPAT","type":"module"},{"doc":"Produces a SPAT message struct from an equivalent map or keyword input","ref":"Kitt.Message.SPAT.html#new/1","title":"Kitt.Message.SPAT.new/1","type":"function"},{"doc":"Returns the SPAT identifying atom recognized by the ASN1 spec","ref":"Kitt.Message.SPAT.html#type/0","title":"Kitt.Message.SPAT.type/0","type":"function"},{"doc":"Returns the SPAT identifying integer","ref":"Kitt.Message.SPAT.html#type_id/0","title":"Kitt.Message.SPAT.type_id/0","type":"function"},{"doc":"","ref":"Kitt.Message.SPAT.html#t:advisory_speed/0","title":"Kitt.Message.SPAT.advisory_speed/0","type":"type"},{"doc":"","ref":"Kitt.Message.SPAT.html#t:connection_maneuver_assist/0","title":"Kitt.Message.SPAT.connection_maneuver_assist/0","type":"type"},{"doc":"","ref":"Kitt.Message.SPAT.html#t:intersection_state/0","title":"Kitt.Message.SPAT.intersection_state/0","type":"type"},{"doc":"","ref":"Kitt.Message.SPAT.html#t:movement_event/0","title":"Kitt.Message.SPAT.movement_event/0","type":"type"},{"doc":"","ref":"Kitt.Message.SPAT.html#t:movement_state/0","title":"Kitt.Message.SPAT.movement_state/0","type":"type"},{"doc":"","ref":"Kitt.Message.SPAT.html#t:status/0","title":"Kitt.Message.SPAT.status/0","type":"type"},{"doc":"Defines the structure of a SignalPhaseandTiming message and the data elements comprising its fields","ref":"Kitt.Message.SPAT.html#t:t/0","title":"Kitt.Message.SPAT.t/0","type":"type"},{"doc":"","ref":"Kitt.Message.SPAT.html#t:time_change_details/0","title":"Kitt.Message.SPAT.time_change_details/0","type":"type"},{"doc":"Defines the structure and instantiation function for creating a J2735-compliant SignalRequestMessage An SRM defines the interchange of a DSRC-capable vehicle with the infrastructure regarding signal and timing information pertaining to an intersection","ref":"Kitt.Message.SRM.html","title":"Kitt.Message.SRM","type":"module"},{"doc":"Produces an SRM message struct from an equivalent map or keyword input","ref":"Kitt.Message.SRM.html#new/1","title":"Kitt.Message.SRM.new/1","type":"function"},{"doc":"Returns the SRM identifying atom recognized by the ASN1 spec","ref":"Kitt.Message.SRM.html#type/0","title":"Kitt.Message.SRM.type/0","type":"function"},{"doc":"Returns the SRM identifying integer","ref":"Kitt.Message.SRM.html#type_id/0","title":"Kitt.Message.SRM.type_id/0","type":"function"},{"doc":"","ref":"Kitt.Message.SRM.html#t:requestor_description/0","title":"Kitt.Message.SRM.requestor_description/0","type":"type"},{"doc":"","ref":"Kitt.Message.SRM.html#t:requestor_position_vector/0","title":"Kitt.Message.SRM.requestor_position_vector/0","type":"type"},{"doc":"","ref":"Kitt.Message.SRM.html#t:signal_request/0","title":"Kitt.Message.SRM.signal_request/0","type":"type"},{"doc":"","ref":"Kitt.Message.SRM.html#t:signal_request_package/0","title":"Kitt.Message.SRM.signal_request_package/0","type":"type"},{"doc":"Defines the structure of a SignalRequestMessage and the data elements comprising its fields","ref":"Kitt.Message.SRM.html#t:t/0","title":"Kitt.Message.SRM.t/0","type":"type"},{"doc":"","ref":"Kitt.Message.SRM.html#t:transit_status/0","title":"Kitt.Message.SRM.transit_status/0","type":"type"},{"doc":"Defines the structure and instantiation function for creating a J2735-compliant SignalStatusMessage An SSM defines the message sent by DSRC-capable infrastructure to relay to vehicles the status of current signals and collection of pending or active pre-emption or requests","ref":"Kitt.Message.SSM.html","title":"Kitt.Message.SSM","type":"module"},{"doc":"Produces an SSM message struct from an equivalent map or keyword input","ref":"Kitt.Message.SSM.html#new/1","title":"Kitt.Message.SSM.new/1","type":"function"},{"doc":"Returns the SSM identifying atom recognized by the ASN1 spec","ref":"Kitt.Message.SSM.html#type/0","title":"Kitt.Message.SSM.type/0","type":"function"},{"doc":"Returns the SSM identifying integer","ref":"Kitt.Message.SSM.html#type_id/0","title":"Kitt.Message.SSM.type_id/0","type":"function"},{"doc":"","ref":"Kitt.Message.SSM.html#t:prioritization_response_status/0","title":"Kitt.Message.SSM.prioritization_response_status/0","type":"type"},{"doc":"","ref":"Kitt.Message.SSM.html#t:signal_requester_info/0","title":"Kitt.Message.SSM.signal_requester_info/0","type":"type"},{"doc":"","ref":"Kitt.Message.SSM.html#t:signal_status/0","title":"Kitt.Message.SSM.signal_status/0","type":"type"},{"doc":"","ref":"Kitt.Message.SSM.html#t:signal_status_package/0","title":"Kitt.Message.SSM.signal_status_package/0","type":"type"},{"doc":"Defines the structure of a SignalStatusMessage and the data elements comprising its fields","ref":"Kitt.Message.SSM.html#t:t/0","title":"Kitt.Message.SSM.t/0","type":"type"},{"doc":"Defines the structure and instantiation function for creating a J2735-compliant Traveler Information message A TIM defines a generic message type used to relay various advisory notifications to equipped devices, including but not limited to vehicles","ref":"Kitt.Message.TIM.html","title":"Kitt.Message.TIM","type":"module"},{"doc":"Produces a TIM message struct from an equivalent map or keyword input","ref":"Kitt.Message.TIM.html#new/1","title":"Kitt.Message.TIM.new/1","type":"function"},{"doc":"Returns the TIM identifying atom recognized by the ASN1 spec","ref":"Kitt.Message.TIM.html#type/0","title":"Kitt.Message.TIM.type/0","type":"function"},{"doc":"Returns the TIM identifying integer","ref":"Kitt.Message.TIM.html#type_id/0","title":"Kitt.Message.TIM.type_id/0","type":"function"},{"doc":"","ref":"Kitt.Message.TIM.html#t:area/0","title":"Kitt.Message.TIM.area/0","type":"type"},{"doc":"","ref":"Kitt.Message.TIM.html#t:circle/0","title":"Kitt.Message.TIM.circle/0","type":"type"},{"doc":"","ref":"Kitt.Message.TIM.html#t:content/0","title":"Kitt.Message.TIM.content/0","type":"type"},{"doc":"","ref":"Kitt.Message.TIM.html#t:description/0","title":"Kitt.Message.TIM.description/0","type":"type"},{"doc":"","ref":"Kitt.Message.TIM.html#t:direction_of_use/0","title":"Kitt.Message.TIM.direction_of_use/0","type":"type"},{"doc":"","ref":"Kitt.Message.TIM.html#t:geographical_path/0","title":"Kitt.Message.TIM.geographical_path/0","type":"type"},{"doc":"","ref":"Kitt.Message.TIM.html#t:geometric_projection/0","title":"Kitt.Message.TIM.geometric_projection/0","type":"type"},{"doc":"","ref":"Kitt.Message.TIM.html#t:itis_item/0","title":"Kitt.Message.TIM.itis_item/0","type":"type"},{"doc":"","ref":"Kitt.Message.TIM.html#t:msg_id/0","title":"Kitt.Message.TIM.msg_id/0","type":"type"},{"doc":"","ref":"Kitt.Message.TIM.html#t:region_offset/0","title":"Kitt.Message.TIM.region_offset/0","type":"type"},{"doc":"","ref":"Kitt.Message.TIM.html#t:region_point_set/0","title":"Kitt.Message.TIM.region_point_set/0","type":"type"},{"doc":"","ref":"Kitt.Message.TIM.html#t:road_sign_id/0","title":"Kitt.Message.TIM.road_sign_id/0","type":"type"},{"doc":"","ref":"Kitt.Message.TIM.html#t:shape_point_set/0","title":"Kitt.Message.TIM.shape_point_set/0","type":"type"},{"doc":"Defines the structure of a TravelerInformation message and the data elements comprising its fields","ref":"Kitt.Message.TIM.html#t:t/0","title":"Kitt.Message.TIM.t/0","type":"type"},{"doc":"","ref":"Kitt.Message.TIM.html#t:traveler_data_frame/0","title":"Kitt.Message.TIM.traveler_data_frame/0","type":"type"},{"doc":"","ref":"Kitt.Message.TIM.html#t:valid_region/0","title":"Kitt.Message.TIM.valid_region/0","type":"type"},{"doc":"Collection of custom typespec definitions for abstracting the complexity of messages away from the structs that define them.","ref":"Kitt.Types.html","title":"Kitt.Types","type":"module"},{"doc":"","ref":"Kitt.Types.html#t:acceleration_set_4_way/0","title":"Kitt.Types.acceleration_set_4_way/0","type":"type"},{"doc":"","ref":"Kitt.Types.html#t:angle/0","title":"Kitt.Types.angle/0","type":"type"},{"doc":"","ref":"Kitt.Types.html#t:antenna_offset_set/0","title":"Kitt.Types.antenna_offset_set/0","type":"type"},{"doc":"","ref":"Kitt.Types.html#t:basic_vehicle_role/0","title":"Kitt.Types.basic_vehicle_role/0","type":"type"},{"doc":"","ref":"Kitt.Types.html#t:brake_system_status/0","title":"Kitt.Types.brake_system_status/0","type":"type"},{"doc":"","ref":"Kitt.Types.html#t:bumper_heights/0","title":"Kitt.Types.bumper_heights/0","type":"type"},{"doc":"","ref":"Kitt.Types.html#t:computed_lane/0","title":"Kitt.Types.computed_lane/0","type":"type"},{"doc":"","ref":"Kitt.Types.html#t:d_date_time/0","title":"Kitt.Types.d_date_time/0","type":"type"},{"doc":"","ref":"Kitt.Types.html#t:disabled_vehicle/0","title":"Kitt.Types.disabled_vehicle/0","type":"type"},{"doc":"","ref":"Kitt.Types.html#t:driven_lane_offset/0","title":"Kitt.Types.driven_lane_offset/0","type":"type"},{"doc":"","ref":"Kitt.Types.html#t:emergency_details/0","title":"Kitt.Types.emergency_details/0","type":"type"},{"doc":"","ref":"Kitt.Types.html#t:event_description/0","title":"Kitt.Types.event_description/0","type":"type"},{"doc":"","ref":"Kitt.Types.html#t:event_flag/0","title":"Kitt.Types.event_flag/0","type":"type"},{"doc":"","ref":"Kitt.Types.html#t:extent/0","title":"Kitt.Types.extent/0","type":"type"},{"doc":"","ref":"Kitt.Types.html#t:full_position_vector/0","title":"Kitt.Types.full_position_vector/0","type":"type"},{"doc":"","ref":"Kitt.Types.html#t:generic_locations/0","title":"Kitt.Types.generic_locations/0","type":"type"},{"doc":"","ref":"Kitt.Types.html#t:incident_response_equipment/0","title":"Kitt.Types.incident_response_equipment/0","type":"type"},{"doc":"","ref":"Kitt.Types.html#t:intersection_access_point/0","title":"Kitt.Types.intersection_access_point/0","type":"type"},{"doc":"","ref":"Kitt.Types.html#t:intersection_reference_id/0","title":"Kitt.Types.intersection_reference_id/0","type":"type"},{"doc":"","ref":"Kitt.Types.html#t:lane_data_attribute/0","title":"Kitt.Types.lane_data_attribute/0","type":"type"},{"doc":"","ref":"Kitt.Types.html#t:minute_of_year/0","title":"Kitt.Types.minute_of_year/0","type":"type"},{"doc":"","ref":"Kitt.Types.html#t:node_attribute/0","title":"Kitt.Types.node_attribute/0","type":"type"},{"doc":"","ref":"Kitt.Types.html#t:node_attribute_set/0","title":"Kitt.Types.node_attribute_set/0","type":"type"},{"doc":"","ref":"Kitt.Types.html#t:node_list_ll/0","title":"Kitt.Types.node_list_ll/0","type":"type"},{"doc":"","ref":"Kitt.Types.html#t:node_list_xy/0","title":"Kitt.Types.node_list_xy/0","type":"type"},{"doc":"","ref":"Kitt.Types.html#t:node_ll/0","title":"Kitt.Types.node_ll/0","type":"type"},{"doc":"","ref":"Kitt.Types.html#t:node_ll_b/0","title":"Kitt.Types.node_ll_b/0","type":"type"},{"doc":"","ref":"Kitt.Types.html#t:node_llmd_64b/0","title":"Kitt.Types.node_llmd_64b/0","type":"type"},{"doc":"","ref":"Kitt.Types.html#t:node_offset_point_ll/0","title":"Kitt.Types.node_offset_point_ll/0","type":"type"},{"doc":"","ref":"Kitt.Types.html#t:node_offset_point_xy/0","title":"Kitt.Types.node_offset_point_xy/0","type":"type"},{"doc":"","ref":"Kitt.Types.html#t:node_xy/0","title":"Kitt.Types.node_xy/0","type":"type"},{"doc":"","ref":"Kitt.Types.html#t:node_xy_24b/0","title":"Kitt.Types.node_xy_24b/0","type":"type"},{"doc":"","ref":"Kitt.Types.html#t:node_xy_b/0","title":"Kitt.Types.node_xy_b/0","type":"type"},{"doc":"","ref":"Kitt.Types.html#t:obstacle_detection/0","title":"Kitt.Types.obstacle_detection/0","type":"type"},{"doc":"","ref":"Kitt.Types.html#t:offset/0","title":"Kitt.Types.offset/0","type":"type"},{"doc":"","ref":"Kitt.Types.html#t:offset_system/0","title":"Kitt.Types.offset_system/0","type":"type"},{"doc":"","ref":"Kitt.Types.html#t:path_history/0","title":"Kitt.Types.path_history/0","type":"type"},{"doc":"","ref":"Kitt.Types.html#t:path_history_point/0","title":"Kitt.Types.path_history_point/0","type":"type"},{"doc":"","ref":"Kitt.Types.html#t:path_prediction/0","title":"Kitt.Types.path_prediction/0","type":"type"},{"doc":"","ref":"Kitt.Types.html#t:pivot_point_description/0","title":"Kitt.Types.pivot_point_description/0","type":"type"},{"doc":"","ref":"Kitt.Types.html#t:position_3d/0","title":"Kitt.Types.position_3d/0","type":"type"},{"doc":"","ref":"Kitt.Types.html#t:position_confidence_set/0","title":"Kitt.Types.position_confidence_set/0","type":"type"},{"doc":"","ref":"Kitt.Types.html#t:positional_accuracy/0","title":"Kitt.Types.positional_accuracy/0","type":"type"},{"doc":"","ref":"Kitt.Types.html#t:privileged_event_flag/0","title":"Kitt.Types.privileged_event_flag/0","type":"type"},{"doc":"","ref":"Kitt.Types.html#t:privileged_events/0","title":"Kitt.Types.privileged_events/0","type":"type"},{"doc":"","ref":"Kitt.Types.html#t:quadrant/0","title":"Kitt.Types.quadrant/0","type":"type"},{"doc":"","ref":"Kitt.Types.html#t:regional_extension/0","title":"Kitt.Types.regional_extension/0","type":"type"},{"doc":"","ref":"Kitt.Types.html#t:regulatory_speed_limit/0","title":"Kitt.Types.regulatory_speed_limit/0","type":"type"},{"doc":"","ref":"Kitt.Types.html#t:requestor_type/0","title":"Kitt.Types.requestor_type/0","type":"type"},{"doc":"","ref":"Kitt.Types.html#t:responder_group_affected/0","title":"Kitt.Types.responder_group_affected/0","type":"type"},{"doc":"","ref":"Kitt.Types.html#t:response_type/0","title":"Kitt.Types.response_type/0","type":"type"},{"doc":"","ref":"Kitt.Types.html#t:road_segment_reference_id/0","title":"Kitt.Types.road_segment_reference_id/0","type":"type"},{"doc":"","ref":"Kitt.Types.html#t:rtcm_header/0","title":"Kitt.Types.rtcm_header/0","type":"type"},{"doc":"","ref":"Kitt.Types.html#t:rtcm_package/0","title":"Kitt.Types.rtcm_package/0","type":"type"},{"doc":"","ref":"Kitt.Types.html#t:segment_attribute/0","title":"Kitt.Types.segment_attribute/0","type":"type"},{"doc":"","ref":"Kitt.Types.html#t:speed_and_heading_and_throttle_confidence/0","title":"Kitt.Types.speed_and_heading_and_throttle_confidence/0","type":"type"},{"doc":"","ref":"Kitt.Types.html#t:speed_limit_type/0","title":"Kitt.Types.speed_limit_type/0","type":"type"},{"doc":"","ref":"Kitt.Types.html#t:speed_profile/0","title":"Kitt.Types.speed_profile/0","type":"type"},{"doc":"","ref":"Kitt.Types.html#t:status/0","title":"Kitt.Types.status/0","type":"type"},{"doc":"","ref":"Kitt.Types.html#t:trailer_data/0","title":"Kitt.Types.trailer_data/0","type":"type"},{"doc":"","ref":"Kitt.Types.html#t:trailer_history_point/0","title":"Kitt.Types.trailer_history_point/0","type":"type"},{"doc":"","ref":"Kitt.Types.html#t:trailer_unit_description/0","title":"Kitt.Types.trailer_unit_description/0","type":"type"},{"doc":"","ref":"Kitt.Types.html#t:transmission_and_speed/0","title":"Kitt.Types.transmission_and_speed/0","type":"type"},{"doc":"","ref":"Kitt.Types.html#t:transmission_state/0","title":"Kitt.Types.transmission_state/0","type":"type"},{"doc":"","ref":"Kitt.Types.html#t:vehicle_classification/0","title":"Kitt.Types.vehicle_classification/0","type":"type"},{"doc":"","ref":"Kitt.Types.html#t:vehicle_data/0","title":"Kitt.Types.vehicle_data/0","type":"type"},{"doc":"","ref":"Kitt.Types.html#t:vehicle_group_affected/0","title":"Kitt.Types.vehicle_group_affected/0","type":"type"},{"doc":"","ref":"Kitt.Types.html#t:vehicle_id/0","title":"Kitt.Types.vehicle_id/0","type":"type"},{"doc":"","ref":"Kitt.Types.html#t:vehicle_size/0","title":"Kitt.Types.vehicle_size/0","type":"type"},{"doc":"","ref":"Kitt.Types.html#t:vehicle_type/0","title":"Kitt.Types.vehicle_type/0","type":"type"},{"doc":"","ref":"Kitt.Types.html#t:vert_event/0","title":"Kitt.Types.vert_event/0","type":"type"},{"doc":"","ref":"Kitt.Types.html#t:weather_probe/0","title":"Kitt.Types.weather_probe/0","type":"type"},{"doc":"","ref":"Kitt.Types.html#t:weather_report/0","title":"Kitt.Types.weather_report/0","type":"type"},{"doc":"","ref":"Kitt.Types.html#t:wheel_brake/0","title":"Kitt.Types.wheel_brake/0","type":"type"},{"doc":"","ref":"Kitt.Types.html#t:wiper_set/0","title":"Kitt.Types.wiper_set/0","type":"type"},{"doc":"","ref":"Kitt.Types.html#t:wiper_status/0","title":"Kitt.Types.wiper_status/0","type":"type"},{"doc":"Utility functions for interacting with data frames and elements for cleaner readability across modules.","ref":"Kitt.Util.html","title":"Kitt.Util","type":"module"},{"doc":"Converts a fixed-size byte identifier field to a human-readable integer","ref":"Kitt.Util.html#decode_id/1","title":"Kitt.Util.decode_id/1","type":"function"},{"doc":"Converts an integer to its 4-byte binary representation for compatibility with common J2735 ID field spec.","ref":"Kitt.Util.html#encode_id/1","title":"Kitt.Util.encode_id/1","type":"function"},{"doc":"Parses a keyword list of options and returns the desired output format for an encode function or the expected input format for a decode function. Defaults to hexadecimal format via the :hex atom if the :format option is not supplied. Returns an {:error, reason} if an unsupported value is supplied for the :format option.","ref":"Kitt.Util.html#get_format/1","title":"Kitt.Util.get_format/1","type":"function"},{"doc":"Ensures data is converted to binary format for compatibility with various fixed-size data element fields in the J2735 message set.","ref":"Kitt.Util.html#to_binary/1","title":"Kitt.Util.to_binary/1","type":"function"},{"doc":"Recursively converts a Kitt message struct to its equivalent Elixir map to allow it to be encoded to binary format. Reduces over the fields of the struct and converts it and any sub-fields defined as structs to a map.","ref":"Kitt.Util.html#to_map_recursive/1","title":"Kitt.Util.to_map_recursive/1","type":"function"},{"doc":"","ref":"Kitt.Util.html#type/1","title":"Kitt.Util.type/1","type":"function"},{"doc":"","ref":"Kitt.DSRCDecodeError.html","title":"Kitt.DSRCDecodeError","type":"exception"},{"doc":"","ref":"Kitt.DSRCEncodeError.html","title":"Kitt.DSRCEncodeError","type":"exception"},{"doc":"kitt description Kitt provides DSRC encoding and decoding functions for Erlang and Elixir and converts decoded message maps to Elixir structs for additional specification enforcement and operations. Incoming messages are UPER-encoded binary payloads in either raw or hexadecimal format. Elixir structs or basic maps producing the necessary fields for a valid message are accepted for encoding. Kitt is named for the talking &quot;smart car&quot; character KITT from the 1980s American television series &quot;Knight Rider&quot;. background Messages, data frames, and their component data elements are based on the 2016-03 ASN1 definition of the J2735 DSRC message set standard developed by the Society of Automative Engineers (SAE). caution Kitt does NOT currently provide any mechanism directly for encoding or decoding regional extensions to the DSRC standard messages, frames, and elememnts, instead instantiating those message components as the :asn1_OPENTYPE followed by the raw binary of the regional extension element. up next Future planned extensions for Kitt include additional serialization/deserialization functionality to convert decoded messages to common interchange formats such as JSON, Protobuf, and Avro, although this functionality has not yet been fully implemented . example decoding iex(1)&gt; Kitt . decode ( &quot;0014251200000A252F24E6D03FEF9CCC88740D5F7FFFFFFFF098D5F0FDFA1FA1007FFF00004B1090&quot; ) { :ok , % Kitt.Message.BSM { coreData : % Kitt.Message.BSM.CoreData { accelSet : %{ lat : 2001 , long : 2001 , vert : - 127 , yaw : 0 } , accuracy : %{ orientation : 65535 , semiMajor : 255 , semiMinor : 255 } , angle : 127 , brakes : %{ abs : :unavailable , ... &lt;= === === == Additional fields omitted for brevity } , elev : 2750 , heading : 22000 , id : &lt;&lt; 0 , 0 , 40 , 148 &gt;&gt; , lat : 402364127 , long : - 833667351 , msgCnt : 72 , secMark : 48275 , size : %{ length : 530 , width : 150 } , speed : 305 , transmission : :unavailable } , partII : nil , regional : nil } } example encoding iex(2)&gt; % Kitt.Message.SPAT { ...(2)&gt; intersections : [ ...(2)&gt; %{ ...(2)&gt; id : %{ id : 1005 , region : 0 } , ...(2)&gt; moy : 322340 , ...(2)&gt; revision : 1 , ...(2)&gt; states : [ ...(2)&gt; %{ ...(2)&gt; signalGroup : 1 , ...(2)&gt; &quot;state-time-speed&quot; : [ ...(2)&gt; %{ ...(2)&gt; eventState : :&quot;stop-And-Remain&quot; , ...(2)&gt; timing : %{ maxEndTime : 12966 , minEndTime : 12636 , startTime : 12166 } ...(2)&gt; } ...(2)&gt; ] ...(2)&gt; } , ...(2)&gt; %{ ...(2)&gt; signalGroup : 2 , ...(2)&gt; &quot;state-time-speed&quot; : [ ...(2)&gt; %{ ...(2)&gt; eventState : :&quot;permissive-Movement-Allowed&quot; , ...(2)&gt; timing : %{ maxEndTime : 12536 , minEndTime : 12436 , startTime : 12166 } ...(2)&gt; } ...(2)&gt; ] ...(2)&gt; } , ...(2)&gt; ... &lt;= === === === = Additional signalGroups omitted for brevity ...(2)&gt; ] , ...(2)&gt; status : [ :trafficDependentOperation ] , ...(2)&gt; timeStamp : 16592 ...(2)&gt; } ...(2)&gt; ] , ...(2)&gt; name : nil , ...(2)&gt; regional : nil , ...(2)&gt; timeStamp : nil ...(2)&gt; } &quot;00136F0018800001F68102004EB2440D009001043C17C318AE1953001022E0BE18C250C3E001010F05F0C6178624000A08782F8630303030006045C17C318041804004021E0BE18C2F0C48002810F05F0C63D067B801808782F8630BC312000E043C17C318AE1953008021E0BE18C2F0C480&quot;","ref":"readme.html","title":"kitt","type":"extras"}]